#include "unp.h"
#include <stdio.h>
#include <stdlib.h>

#define TRUE 1
#define FALSE 0

// define list
typedef struct db_t
{
        struct db_t *prev;
        int socket_num;
        int port;
        char *ip;
        struct db_t *next;
} db_t;

//define function
struct db_t *init(int, int, char*);
struct db_t *make(int, int, char*);
int sock_add(struct db_t*, struct db_t*, struct db_t*);
int sock_del(struct db_t*, struct db_t*, struct db_t*);

//function detail - initiation
struct db_t *init(int sock_num, int port, char *ip)
{
        struct db_t *head;
        head = make(sock_num, port, ip);
        head->prev=head;
//      head->socket_num=sock_num;
//      head->port=port;
//      head->ip=ip;
        head->next=head;

        return head;
}
//function detail - make socket structure
struct db_t *make(int sock_num, int port, char *ip)
{
        struct db_t *temp;
        temp=(struct db_t*)malloc(sizeof(struct db_t));
        if (!temp)
        {
                printf("Unable make structure\n");
                return NULL;
        }
        temp->socket_num=sock_num;
        temp->port=port;
        temp->ip=ip;

        return temp;
}
//function detail - adding
int sock_add(struct db_t *prev, struct db_t *value, struct db_t *next)
{
        prev->next = value;
        value->prev = prev;

        value->next = prev;
        next->prev = value;

        return TRUE;
}
//function detail - deleting
int sock_del(struct db_t *prev, struct db_t *value,struct db_t *next)
{
        struct db_t *temp;
        temp = value->next;
        value->prev = value->next;
        value->next = temp;
        free(value);

        return TRUE;
}

void str_cli(FILE *fp, int sockfd)
{
	int		stdineof, n, maxfdp1;
	char		buf[MAXLINE];
	fd_set		rset;
	stdineof = 0;
	
        for ( ; ; ) {
                //printf("rset value before FD_SET : %d%n", rset);

                if (stdineof == 0)
                        FD_SET(fileno(fp), &rset);

                FD_SET(sockfd, &rset);

                maxfdp1 = max(fileno(fp), sockfd) + 1;
                select(maxfdp1, &rset, NULL, NULL, NULL);       

                if (FD_ISSET(sockfd, &rset)) {  /* socket is readable */
                        if ( (n = read(sockfd, buf, MAXLINE)) == 0) {
                                if (stdineof == 1)
                                        return;         /* normal termination */
                                else
                                        err_quit("str_cli: server terminated prematurely");
                        }

                        write(fileno(stdout), buf, n);
		}

                if (FD_ISSET(fileno(fp), &rset)) {  /* input is readable */
                        if ( (n = read(fileno(fp), buf, MAXLINE)) == 0) {
                                stdineof = 1;
                                shutdown(sockfd, SHUT_WR);      /* send FIN */
                                FD_CLR(fileno(fp), &rset);
                                continue;
                        }
                }
	}
}
