#include <stdio.h>
#include <string.h>
#include <malloc.h>

#define TRUE 1
#define FALSE 0

// define list
typedef struct db_t
{
	struct db_t *prev;
	int socket_num;
	int port;
	char *ip;
	struct db_t *next;
} db_t;

//define function
struct db_t *init(int, int, char*);
struct db_t *make(int, int, char*);
int sock_add(struct db_t*, struct db_t*, struct db_t*);
int sock_del(struct db_t*, struct db_t*, struct db_t*);

//function detail - initiation
struct db_t *init(int sock_num, int port, char *ip)
{
	struct db_t *head;
	head = make(sock_num, port, ip);
	head->prev=head;
//	head->socket_num=sock_num;
//	head->port=port;
//	head->ip=ip;
	head->next=head;

	return head;
}
//function detail - make socket structure
struct db_t *make(int sock_num, int port, char *ip)
{
	struct db_t *temp;
	temp=(struct db_t*)malloc(sizeof(struct db_t));
	if (!temp)
	{
		printf("Unable make structure\n");
		return NULL;
	}
	temp->socket_num=sock_num;
	temp->port=port;
	temp->ip=ip;

	return temp;
}
//function detail - adding
int sock_add(struct db_t *prev, struct db_t *value, struct db_t *next)
{
	prev->next = value;
	value->prev = prev;
	
	value->next = prev;
	next->prev = value;
	
	return TRUE;
}
//function detail - deleting
int sock_del(struct db_t *prev, struct db_t *value,struct db_t *next)
{
	struct db_t *temp;
	temp = value->next;
	value->prev = value->next;
	value->next = temp;
	free(value);
	
	return TRUE;
}

