#include "unp.h"

#define TRUE 1
#define FALSE 0

// define list
typedef struct db_t
{
        struct db_t *prev;
        int socket_num;
        int port;
        char *ip;
        struct db_t *next;
} db_t;

typedef struct packet
{
	char *ip[256];
	int port[256];
} packet;

//define function
struct db_t *init(int, int, char*);
struct db_t *make(int, int, char*);
int sock_add(struct db_t*, struct db_t*, struct db_t*);
int sock_del(struct db_t*, struct db_t*, struct db_t*);

//function detail - initiation
struct db_t *init(int sock_num, int port, char *ip)
{
        struct db_t *head;
        head = make(sock_num, port, ip);
        head->prev=head;
//      head->socket_num=sock_num;
//      head->port=port;
//      head->ip=ip;
        head->next=head;

        return head;
}
//function detail - make socket structure
struct db_t *make(int sock_num, int port, char *ip)
{
        struct db_t *temp;
        temp=(struct db_t*)malloc(sizeof(struct db_t));
        if (!temp)
        {
                printf("Unable make structure\n");
                return NULL;
        }
        temp->socket_num=sock_num;
        temp->port=port;
        temp->ip=ip;

        return temp;
}
//function detail - adding
int sock_add(struct db_t *prev, struct db_t *value, struct db_t *next)
{
        prev->next = value;
        value->prev = prev;
	value->next = next;
        next->prev = value;

        return TRUE;
}
//function detail - deleting
int sock_del(struct db_t *prev, struct db_t *value,struct db_t *next)
{
        struct db_t *temp;
        temp = value->next;
        value->prev = value->next;
        value->next = temp;
        free(value);

        return TRUE;
}

int main()
{
	int 			listenfd, connfd, sockfd, maxi, maxfd, i, j, connect_count;
	int			nready, client[FD_SETSIZE];
	ssize_t			n;
	fd_set			rset, allset;
	socklen_t 		clilen;
	struct 			sockaddr_in cliaddr, servaddr;
	char 			*cli_addr;
	int 			cli_port;
	char			buf[256];
	struct db_t		*first, *temp, *temp2;
	struct packet		broadcast;
	connect_count=0;

	listenfd = socket(AF_INET, SOCK_STREAM, 0);

	bzero(&servaddr, sizeof(servaddr));
	servaddr.sin_family	 = AF_INET;
        servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
	servaddr.sin_port	 = htons(SERV_PORT);

	bind(listenfd, (SA *) &servaddr, sizeof(servaddr));

	listen(listenfd, LISTENQ);

	maxfd = listenfd;
	maxi = -1;

	for (i=0 ; i < FD_SETSIZE ; i++)
		client[i] = -1;
	FD_ZERO(&allset);
	FD_SET(listenfd, &allset);
	
	printf("\nWaiting client's connection\n");

	first=(struct db_t*)malloc(sizeof(struct db_t));
	temp=(struct db_t*)malloc(sizeof(struct db_t));
	temp2=(struct db_t*)malloc(sizeof(struct db_t));
	
	for ( ; ; )
	{
		rset = allset;
		nready = select (maxfd+1, &rset, NULL, NULL, NULL);
		if(FD_ISSET(listenfd, &rset))			// new client connection
		{
	                clilen = sizeof(cliaddr);
        	        connfd = accept(listenfd, (SA *) &cliaddr, &clilen);

			for (i=0 ; i <FD_SETSIZE ; i++)
			{
				if (client[i] < 0) 
				{

					cli_addr = NULL;
					cli_port = 0;
					client[i] = connfd;
printf("b last %s         %d\n", first->ip, first->port);
						
					cli_addr = inet_ntoa(cliaddr.sin_addr);

printf("c last %s         %d\n", first->ip, first->port);

	                       		cli_port = ntohs(cliaddr.sin_port);

					connect_count++;
					if (connect_count==1)
					{
						first=init(connect_count, cli_port, cli_addr);
						temp = first;
					}
					else
					{
						temp2=make(connect_count, cli_port, cli_addr);
						sock_add(temp, temp2, first);
						temp=temp2;
					}

					printf("%d clinet connected\n", connfd);
					printf("%d	%s	%d	\n", 
						temp->socket_num, temp->ip, temp->port);
					break;
				}
			}
			if (i == FD_SETSIZE)
				err_quit("too many clients");

			FD_SET(connfd, &allset);
			// set max value
			if (connfd > maxfd)
				maxfd = connfd;
			if (i>maxi)
				maxi = i;
/*
			// set packet (using list)
			for (i=maxi ; i<256 ; i++)
			{
				broadcast.ip[i] = NULL ; 
				broadcast.port[i] = 0 ; 
			}

                        broadcast.ip[0] = first->ip;
			printf("kkk %s \n", broadcast.ip[0]);
                        broadcast.port[0] = first->port;
			printf("kkk %d \n", broadcast.port[0]);

			temp=first;
 
			for (i=1 ; i <= maxi ; i++)
			{
				broadcast.ip[i] = temp->next->ip;
				broadcast.port[i] = temp->next->port;
				temp=temp->next;
			}

                        for (i=0 ; i <= maxi ; i++)
                        {
                                printf("%s	", broadcast.ip[i]);
				printf("%d\n", broadcast.port[i]);
                        }
*/
			// broadcast struct packet
			for (i=0 ; i <= maxi ; i++)
				writen(client[i], "hello", sizeof("hello"));				
			// loop number
			if (--nready <= 0)
				continue;
		}
                for (i = 0; i <= maxi; i++) {   /* check all clients for data */
                        if ( (sockfd = client[i]) < 0)
                                continue;
                        if (FD_ISSET(sockfd, &rset)) {
                                if ( (n = read(sockfd, buf, MAXLINE)) == 0) {
                                                /* connection closed by client */
                                        close(sockfd);
                                        FD_CLR(sockfd, &allset);
					printf("%d client terminated\n", sockfd);
					for (j=0 ; j <=maxi ; j++)
					{
						if (client[j]!=sockfd)
							writen(client[j], "bye", sizeof("bye"));
					}
                                        client[i] = -1;
                     		}
				if (--nready <= 0)
                                        break;                          /* no more readable descriptors */
                        }
                }
	}
	free(first);
	free(temp);
	free(temp2);
}

